#ifndef __7ZIPDATASTREAM_H__
#define __7ZIPDATASTREAM_H__

#include "7zip/IStream.h"
#include "Common/MyCom.h"

class CInDataStream: 
	public IInStream,
	public IStreamGetSize,
	public CMyUnknownImp
{
public:
	CInDataStream() {}
	virtual ~CInDataStream() {}

	void LoadData ( unsigned char *data, long max ) { m_sData = data; m_lMaxSize = max; m_lCurPos = 0; }

	MY_UNKNOWN_IMP2(IInStream, IStreamGetSize)

	STDMETHOD(Read)(void *data, UInt32 size, UInt32 *processedSize);
	STDMETHOD(Seek)(Int64 offset, UInt32 seekOrigin, UInt64 *newPosition);

	STDMETHOD(GetSize)(UInt64 *size);

private:
	unsigned char *m_sData;
	long  m_lCurPos;
	long  m_lMaxSize;
};

class COutDataStream: 
	public IOutStream,
	public CMyUnknownImp
{
public:
	COutDataStream() { m_sData = NULL; }
	virtual ~COutDataStream() { }//if ( m_sData ) free ( m_sData ); }
	void Create ( long size );
  
	MY_UNKNOWN_IMP1(IOutStream)

	STDMETHOD(Write)(const void *data, UInt32 size, UInt32 *processedSize);
	STDMETHOD(Seek)(Int64 offset, UInt32 seekOrigin, UInt64 *newPosition);
	STDMETHOD(SetSize)(Int64 newSize);

	unsigned char *GetData () { return m_sData; }
	long  GetCurrentSize () { return m_lCurPos; }

private:
	unsigned char *m_sData;
	long  m_lCurPos;
	long  m_lMaxSize;
};

#endif //__7ZIPDATASTREAM_H__